<!doctype html>
<html>

	<head>

		<title>DashGL | OpenGL Tutorials</title>

		<meta charset="utf-8"/>
		<meta name="viewport" content="width=device-width,initial-scale=1.0,user-scalable=no"/>
		<meta name="description" content="Tutortials for Linux programming using EGL, C, and OpenGL"/>
		<meta name="keywords" content="Linux,C,OpenGL,Tutorial,EGL,Raspberry Pi"/>
		<meta name="author" content="Benjamin Collins - Kion"/>

		<link rel="shortcut icon" type="image/png" href="../../img/favicon.png"/>
		<link rel="stylesheet" type="text/css" href="../../css/layout.css"/>
		<link rel="stylesheet" type="text/css" href="../../css/responsive.css"/>

	</head>

	<body>
			
			<header>
				
				<div class="align">

				<table id="Navbar.table">
					<tr>
						<td class="title">
							<h1>
								<img src="../../img/Logo&#32;Transparency.png"/>
							</h1>
						</td>
						<td></td>
						<!--
						<td class="link">
							<a href="/basics/">
								<div class="img basics"></div>
								Basics
							</a>
						</td>
						<td class="link">
							<a href="/brickout/">
								<div class="img"></div>
								Brickout
							</a>
						</td>
						<td class="link">
							<a href="/invaders/">
								<div class="img"></div>
								Invaders
							</a>
						</td>
						<td class="link">
							<a href="/astroids/">
								<div class="img"></div>
								Astroids
							</a>
						</td>
						-->
						<td class="icon menu">
							<img src="https://dashgl.com/basics/fade/img/menu_icon.png"/>
						</td>
					</tr>
				</table>

				</div>

			</header>

			<div id="MobileNav.toggle" class="mobile-nav astroids">

				<h2 id="MobileNav.header">Contents</h2>

				<ul id="MobileNav.content">

					<li class="on">Article 01</li>
					<li class="on">Article 02</li>
					<li class="on active">Article 03</li>
					<li>Article 04</li>
					<li>Article 05</li>
					<li>Article 06</li>

				</ul>

			</div>

			<section>

				<menu>
					<div class="header">Table of Contents</div>
					<img src="../../img/others_20171117_dashgl_dash_cropped_icon_eee.png"/>
					
		<a href='../forward/index.html'>
			<li>
				Forward
			</li>
		</a>
	
		<a href='../triangle/index.html'>
			<li>
				Blue Triangle
			</li>
		</a>
	
		<a href='../square/index.html'>
			<li>
				Red Square
			</li>
		</a>
	
		<a href='../circle/index.html'>
			<li>
				Green Circle
			</li>
		</a>
	
		<a href='../color/index.html'>
			<li>
				Fragment Color
			</li>
		</a>
	
		<a href='../multiple/index.html'>
			<li>
				Multiple Shapes
			</li>
		</a>
	
		<a href='index.html'>
			<li class='active'>
				Fade In and Out
			</li>
		</a>
	
		<a href='../transform/index.html'>
			<li>
				Transform Triangle
			</li>
		</a>
	
		<a href='../cube/index.html'>
			<li>
				Draw a Cube
			</li>
		</a>
	
		<a href='../texture/index.html'>
			<li>
				Textured Cube
			</li>
		</a>
	
		<a href='../dashie/index.html'>
			<li>
				Render Model
			</li>
		</a>
	
					<div class="footer"></div>
				</menu>

				<article>
					
					<div class="header">Article Contents</div>

					<div class="content" id="NavBar.content.body">

						<table class="summary">
<tr>
<td class="title">
<h2>Fade In and Out</h3>
<li>Created on: June 8, 2020</li>
<li>By: Kion</li>
</td>
<td class="code">

    <a href="https://gitlab.com/dashgl/dashie/-/tree/master/06_fade" target="_blank">
        <div class="icon"></div>
        View code on Gitlab
    </a>

</td>
</tr>
</table>

<h3>Summary</h3>

<p>
In this article we take the step where we start to make changes during runtime. Up to
now we've only drawn static images that don't change, so in this article we draw a
triangle to the screen that fades in and out. The way we accomplish this is by using 
uniforms which are a specific value that can be changed by the CPU-side of code,
and updated in the GPU-memory as needed. The output of this article is given below.
</p>

<video class="fig" controls>
	<source type="video/mp4" src="../../img/DZ-MV2w9nQZMTwzY.mp4"/>
</video>

<p>
In this artcile, we will work on a triangle that fades in and out. Up until now
we've only been displaying static images, that might have well been rendered to
an image file instead of being run in a program. In this example we will be updating
the alpha value of the triangle for every frame that is drawn in order to create
an effect that is dependent on time. In order to do this we will be using a <span>uniform</span>
variable type in our shader.
</p>

<p>
A <span>uniform</span> variable is a variable that will get set a value and retain that
value until the next time it is updated. This is different from the <span>attribute</span>
types we are using, which are more like slots that get filled with a value from a buffer.
In this example we will be using the cpu to calculate how long the program has been running,
and put that value to manage an aplha variable whose value ranges between 0 and 1. Let's
go ahead and look at our shaders, and then our <span>init_shaders<span> function to see how
we will approach this article.
</p>

<pre data-file="shaders/vertex.glsl">
attribute vec2 coord2d;
attribute vec3 v_color;
varying vec3 f_color;

void main(void) {
	gl_Position = vec4(coord2d, 0.0, 1.0);
	f_color = v_color;
}
</pre>

<p>
We are using the same vertex shader as from the previous article. We have a <span>vec2 coord2d</span>
for the position of the triangles and a <span>vec3 v_color</span> attribute that we use to 
set the <span>varying vec3 f_color</span> attribute to be passed into the fragment shader.
</p>

<pre data-file="shaders/fragment.glsl">
uniform float fade;
varying vec3 f_color;

void main(void) {
	gl_FragColor = vec4(f_color, fade);
}
</pre>

<p>
As for the fragment shader we have a new addition. From the previous article we have the same 
expression for setting the pixel color from vertex color with <span>varying vec3 f_color</span>
and <span>gl_FragColor = vec4(f_color, fade)</span>. The difference is that we have a new 
<span>fade</span> variable that it a <span>uniform float</span> type. So basically a uniform
value is a value that once it's set, it will retain that value until updated again. In that
case we're using <span>fade</span> as a value for the alpha, so if we set it to 0.5, the triangle
will be drawn at half opacity until the value is updated again. So let's then look at the 
<span>init_buffers</span> function to see how we get the reference to the shader.
</p>

<pre data-file="main.c">
static void init_buffers(GLOBAL_T *state) {

	...

	const char *uniform_name = "fade";
	state->uniform_fade = glGetUniformLocation(state->program, uniform_name);
	if(state->uniform_fade == -1) {
		fprintf(stderr, "Could not bind uniform %s\n", uniform_name);
		return;
	}

	...

}
</pre>

<p>
Not suprisingly we get the reference to the uniform variable like we do with the other attributes,
so not to much new there. The only difference is we call the function <span>glGetUniformLocation</span>
instead of <span>glGetAttribLocation</span>. Last, let's take a look at how we draw the
triangles.
</p>

<pre data-file="main.c">
static void draw_triangles(GLOBAL_T *state) {
	
	glBindFramebuffer(GL_FRAMEBUFFER,0);
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

	glBindBuffer(GL_ARRAY_BUFFER, state->triangle);
	glUseProgram ( state->program );

	state->fade += state->fade_dx;
	if(state->fade <= 0.0f) {
		state->fade = 0.0f;
 		state->fade_dx *= -1.0f;
	} else if(state->fade >= 1.0f) {
 		state->fade = 1.0f;
 		state->fade_dx *= -1.0f;
	}

    glUniform1f(state->uniform_fade, state->fade);

	glVertexAttribPointer(
		state->attr_coord,
		2,
		GL_FLOAT,
		GL_FALSE,
		sizeof(float) * 5,
		0
	);

	glVertexAttribPointer(
		state->attr_color,
		3,
		GL_FLOAT,
		GL_FALSE,
		sizeof(float) * 5,
		(void*)(sizeof(float) * 2)
	);

	glDrawArrays(GL_TRIANGLES, 0, 3);
	
	glFlush();
	glFinish();

}
</pre>

<p>
In the <span>main</span> function we call the <span>draw_triangles</span>
function in a for-loop. This means that effectively the function is being called
every few milliseconds. Normally this would be called at 30 frames per second, 
or 60 frames per seconds, but I don't know how to limit the speed for a consistent
framerame, or how to sync up with the refresh rate. So I think the function is
being called as soon as it completes. Though that just means that we adjust the
rate of the fade so that it looks decent.
</p>

<p>
If we were cool kids then we might try using a sin curve to adjust the opacity
of the triangle. But to be lazy we can simply increment the opacity by either
decreasing it a little bit (ex. 0.01) each frame, or increasing it by a little bit.
Which is what we do with this following bit of code. If the opacity becomes less
than or equal to zero, then we specifically set the opacity value to zero and
multiply the increment value by negative one to start adding. And likewise once
we get to 1.0 opacity, we multiply the increment value by negative one to 
start decreasing the opacity. And then last we call 
<span>glUniform1f(state->uniform_fade, state->fade)</span> to update the value in
the shader.
</p>

<h3>Review</h3>

<p>
You might be wondering about the elephant in the room that is the source code that
appears in the background behind the triangle when it's faded. And to be honest
I'm nto entirely sure how to fix this. If you remember back from the first
article where we created a surface to draw on. The reason for the console text appearing
is probably because the opacity of the triangle ends up showing the surface under it,
which is the surface that shows the console. It's not intentional, but I think it's
a pretty cool effect which is why I left it in there. In terms of approach for
fixes, I think there is an option to discard lower layers, or maybe there's the
more boring approach of drawing a black square before drawing the triangle. In the
next article we will start moving our triangle around.
</p>


					</div>

					<div class="footer"></div>

				</article>

				<div class="line"></div>

			</section>

			<footer>

				<div class="align">

					<!--

					<ul>
						<h5>Tutorials</h5>
						<li>
							<a href="/basics/">Basics</a>
						</li>
						<li>
							<a href="/brickout/">Brickout</a>
						</li>
						<li>
							<a href="/invaders/">Invaders</a>
						</li>
						<li>
							<a href="/astroids/">Astroids</a>
						</li>
					</ul>

					<ul>
						<h5>Information</h5>
						<li>
							<a href="/info/about/">About</a>
						</li>
						<li>
							<a href="/info/mascot/">Mascot</a>
						</li>
						<li>
							<a href="/info/resources/">Resources</a>
						</li>
						<li>
							<a href="/info/contribute/">Contribute</a>
						</li>
					</ul>

					<ul>
						<h5>Sites</h5>
						<li>
							<a href="https://gtk.dashgl.com">Gtk Tutorials</a></li>
						<li>
							<a href="https://blog.dashgl.com">DashGL Blog</a>
						</li>
						<li>
							<a href="https://gitlab.com/dashgl/format">Model Format</a>
						</li>
						<li>
							<a a href="https://mml.dashgl.com/">Rockman Dash</a>
						</li>
					</ul>


					<div class="social">
						<h5>&nbsp;</h5>
						<table>
							<tr>
								<td>
									<a href="https://www.youtube.com/channel/UCGGYpxGASdAOmSp36lhTiIw" target="_blank">
									<div class="parent">
										<div class="icon youtube">
										</div>
										<span>Youtube</span>
									</div>
									</a>
								</td>
								<td>
									<a href="https://twitter.com/kion_dgl" target="_blank">
									<div class="parent">
									<div class="icon twitter">
									</div>
										<span>Twitter</span>
									</div>
									</a>
								</td>
								<td>
									<a href="https://gitlab.com/kion-dgl" target="_blank">
									<div class="parent">
									<div class="icon gitlab">
									</div>
										<span>Gitlab</span>
									</div>
									</a>
								</td>
								<td>
									<a href="https://www.bitchute.com/channel/IWdMNKd3lZye/" target="_blank">
									<div class="parent">
									<div class="icon bitchute">
									</div>
										<span>Bitchute</span>
									</div>
									</a>
								</td>
								<td>
									<a href="https://en.liberapay.com/DashGLProject/" target="_blank">
									<div class="parent">
									<div class="icon liberapay">
									</div>
										<span>LiberaPay</span>
									</div>
									</a>
								</td>
							</tr>
							<tr>
								<td>
									<a href="https://linuxrocks.online/invite/tMcWZehg" target="_blank">
									<div class="parent">
									<div class="icon mastodon"></div>
									<span>Mastodon</span>
									</div>
									</a>
								</td>
								<td>
									<a href="https://www.minds.com/DashGL" target="_blank">
									<div class="parent">
									<div class="icon minds"></div>
									<span>Minds</span>
									</div>
								</td>
								<td>
									<a href="https://brave.com/download/" target="_blank">
									<div class="parent">
									<div class="icon bat"></div>
										<span>Brave</span>
									</div>
									</a>
								</td>
								<td>
									<a href="https://www.reddit.com/user/kion_dgl" target="_blank">
									<div class="parent">
									<div class="icon reddit"></div>
									<span>Reddit</span>
									</div>
									</a>
								</td>
								<td>
									<a href="https://gab.com/kion" target="_blank">
									<div class="parent">
									<div class="icon gab"></div>
									<span>Gab</span>
									</div>
									</a>
								</td>
							</tr>
						</table>

					</div>
					-->

				<div class="copyright">
					Copyright &copy; 2017-2020 DashGL Project
				</div>

				</div>

			</footer>

		</main>

	</body>

</html>
